// BoostC version : 6.95
// Single user Full License for 1 node
// Target         : PIC18F2420
// Adappted to use with the nRF24L01
// by Martin Hug 2012
//
// The receiver UNIT is connected to a serial port through a terminal 
// and waits for incomming data.
////////////////////////////////////////////////////////////////////////////

#include <system.h>
#include "NG_RX_V1.h"
#include "GLOBAL_VAR.h"
#include "serial.h"
#include "nrf24L01.h"
#include <PIC18f2420.h>

#ifdef _PIC18
#pragma DATA _CONFIG1H, _OSC_INTIO67_1H	  // Int OSC, Port RA6,RA7 I/O.
#pragma DATA _CONFIG2H, _WDT_OFF_2H       
#pragma DATA _CONFIG3H, _MCLRE_OFF_3H	
#endif _PIC18

#pragma CLOCK_FREQ 8000000			          // CLK 8Mhz.

#define PW_LED lata.0                     // PW LED.


void main()
{
	init();                                 // device and peripheral initialisation.                     
  unsigned char get_byte;
  char count = 0x02;
  
  nrf_rx_mode();                          // nRF receiver mode & power up.

 	while (1){

     
     PW_LED_OnOff();                      // toggle LED  Off.
     while (nrf_irq_jack());              // waits for data return and checks serial port.
     nrf_read_fifo();                     // reads data from the payload.
     while (count < 5){
       get_byte = nrf_get_byte(count);    // gets the data from data[] array.
       serial_printf(get_byte);           // print the return value to the terminal.
       count++;
       }
       count = 0x02;                      // set the pointer in spi_exchange function.
       nrf_reset_status();                // clear nrf24L01 status reg.
       }
             
 }
//
//

void init(){

  osccon = 01110000b;                     // internal oscillator at 8 MHz.
  while (!iofs);                          // iofs OSCCON stable bit.

  trisa = 00000000b;                      // POPTA all out.
  trisb = 00000000b;                      // POPTA all out.
  trisc = 00000001b;                      // PORTC,0 IRQ, input is connected to nRF24L01 (active low)
  portc = 0x00;                           // change this if needed. (loock also at nrf25L01.h).
  portb = 0x00;                           // change this if needed. (loock also at nrf25L01.h).

	adcon1 |= 0x0F;                         // All digital IO's, no analog ports required.

  intcon = INTCON_CONF;                   // enable global interrupt.
  peie = false;

 	
	  // Serial interface
	  serial_init(34);                      // (34) 57600 baud; DEBUG before BRG = 103 (19200 baud at 8MHz).
	  serial_printf("initializing serial port");
	  serial_print_lf();
	
	  // Wireless interface
	  nrf_init();
	  serial_printf("nRF24L01 config done...");
	  serial_print_lf();
   return;
}
//
//

void PW_LED_OnOff(){

	PW_LED = ~PW_LED;                       //toggle PW_LED (connected to PORTD,5).
}
//
// end of code.
